org.bouncycastle.crypto.modes

## Class SICBlockCipher

- java.lang.Object
- - org.bouncycastle.crypto.modes.SICBlockCipher

All Implemented Interfaces:
  BlockCipher

    public class SICBlockCipher
    extends java.lang.Object
    implements BlockCipher

Implements the Segmented Integer Counter (SIC) mode on top of a simple block cipher. This mode is also known as CTR mode.

### Constructor Summary

Constructors
Constructor and Description
`SICBlockCipher(BlockCipher c)` Basic constructor.

### Method Summary

Methods
`java.lang.String` `getAlgorithmName()` Return the name of the algorithm the cipher implements.
`int` `getBlockSize()` Return the block size for this cipher (in bytes).
`BlockCipher` `getUnderlyingCipher()` return the underlying block cipher that we are wrapping.
`void` `init(boolean forEncryption, CipherParameters params)` Initialise the cipher.
`int` `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
`void` `reset()` Reset the cipher.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SICBlockCipher

    public SICBlockCipher(BlockCipher c)

Basic constructor.

Parameters:
  `c` - the block cipher to be used.

### Method Detail

#### getUnderlyingCipher

    public BlockCipher getUnderlyingCipher()

return the underlying block cipher that we are wrapping.

Returns:
  the underlying block cipher that we are wrapping.

#### init

    public void init(boolean forEncryption,
            CipherParameters params)
              throws java.lang.IllegalArgumentException

Description copied from interface: `BlockCipher`
Initialise the cipher.

Specified by:
  `init` in interface `BlockCipher`
Parameters:
  `forEncryption` - if true the cipher is initialised for encryption, if false for decryption.
  `params` - the key and other data required by the cipher.
Throws:
  `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

#### getAlgorithmName

    public java.lang.String getAlgorithmName()

Description copied from interface: `BlockCipher`
Return the name of the algorithm the cipher implements.

Specified by:
  `getAlgorithmName` in interface `BlockCipher`
Returns:
  the name of the algorithm the cipher implements.

#### getBlockSize

    public int getBlockSize()

Description copied from interface: `BlockCipher`
Return the block size for this cipher (in bytes).

Specified by:
  `getBlockSize` in interface `BlockCipher`
Returns:
  the block size for this cipher in bytes.

#### processBlock

    public int processBlock(byte[] in,
                   int inOff,
                   byte[] out,
                   int outOff)
                     throws DataLengthException,
                            java.lang.IllegalStateException

Description copied from interface: `BlockCipher`
Process one block of input from the array in and write it to the out array.

Specified by:
  `processBlock` in interface `BlockCipher`
Parameters:
  `in` - the array containing the input data.
  `inOff` - offset into the in array the data starts at.
  `out` - the array the output data will be copied into.
  `outOff` - the offset into the out array the output will start at.
Returns:
  the number of bytes processed and produced.
Throws:
  `DataLengthException` - if there isn't enough data in in, or space in out.
  `java.lang.IllegalStateException` - if the cipher isn't initialised.

#### reset

    public void reset()

Description copied from interface: `BlockCipher`
Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).

Specified by:
  `reset` in interface `BlockCipher`